#![allow(deprecated)]
use std::fmt;
use std::str;
#[derive(
    Debug,
    Clone,
    PartialEq,
    Eq,
    PartialOrd,
    Ord,
    Hash,
    conjure_object::serde::Deserialize,
    conjure_object::serde::Serialize,
)]
#[serde(crate = "conjure_object::serde")]
pub enum WindowSymmetry {
    /// Generates dft-even/periodic window values.
    #[serde(rename = "DFT_EVEN")]
    DftEven,
    /// Generates symmetric window values.
    #[serde(rename = "SYMMETRIC")]
    Symmetric,
    /// An unknown variant.
    #[serde(untagged)]
    Unknown(Unknown),
}
impl WindowSymmetry {
    /// Returns the string representation of the enum.
    #[inline]
    pub fn as_str(&self) -> &str {
        match self {
            WindowSymmetry::DftEven => "DFT_EVEN",
            WindowSymmetry::Symmetric => "SYMMETRIC",
            WindowSymmetry::Unknown(v) => &*v,
        }
    }
}
impl fmt::Display for WindowSymmetry {
    fn fmt(&self, fmt: &mut fmt::Formatter) -> fmt::Result {
        fmt::Display::fmt(self.as_str(), fmt)
    }
}
impl conjure_object::Plain for WindowSymmetry {
    fn fmt(&self, fmt: &mut fmt::Formatter) -> fmt::Result {
        conjure_object::Plain::fmt(self.as_str(), fmt)
    }
}
impl str::FromStr for WindowSymmetry {
    type Err = conjure_object::plain::ParseEnumError;
    #[inline]
    fn from_str(
        v: &str,
    ) -> Result<WindowSymmetry, conjure_object::plain::ParseEnumError> {
        match v {
            "DFT_EVEN" => Ok(WindowSymmetry::DftEven),
            "SYMMETRIC" => Ok(WindowSymmetry::Symmetric),
            v => v.parse().map(|v| WindowSymmetry::Unknown(Unknown(v))),
        }
    }
}
impl conjure_object::FromPlain for WindowSymmetry {
    type Err = conjure_object::plain::ParseEnumError;
    #[inline]
    fn from_plain(
        v: &str,
    ) -> Result<WindowSymmetry, conjure_object::plain::ParseEnumError> {
        v.parse()
    }
}
///An unknown variant of the WindowSymmetry enum.
#[derive(
    Debug,
    Clone,
    PartialEq,
    Eq,
    PartialOrd,
    Ord,
    Hash,
    conjure_object::serde::Deserialize,
    conjure_object::serde::Serialize,
)]
#[serde(crate = "conjure_object::serde", transparent)]
pub struct Unknown(conjure_object::private::Variant);
impl std::ops::Deref for Unknown {
    type Target = str;
    #[inline]
    fn deref(&self) -> &str {
        &self.0
    }
}
impl fmt::Display for Unknown {
    #[inline]
    fn fmt(&self, fmt: &mut fmt::Formatter<'_>) -> fmt::Result {
        fmt::Display::fmt(&self.0, fmt)
    }
}
